package com.fxy.fms.putOut;

import android.annotation.SuppressLint;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.KeyEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.chad.library.adapter.base.BaseViewHolder;
import com.elvishew.xlog.XLog;
import com.google.zxing.Result;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;
import com.fxy.baselibrary.base.BaseActivity;
import com.fxy.baselibrary.bean.BaseEventBusBean;
import com.fxy.baselibrary.interfaces.OnRxScanerListener;
import com.fxy.baselibrary.util.JsonUtil;
import com.fxy.R;
import com.fxy.bean.ActionBean;
import com.fxy.bean.ScanBean;
import com.fxy.constant.BaseConfig;
import com.fxy.constant.EventCode;
import com.fxy.net.MyDialogCallback;
import com.fxy.net.Urls;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;
import sto.android.app.StoJNI;
import sto.android.app.StoPdaKeyEvent;
import sto.android.app.StoTongJNI;

public class StorageChecklistMainActivity extends  BaseActivity implements StoJNI.ScanCallBack {
    /**
     * 列表适配器
     */
    Context mContext = this;


    @BindView(R.id.rc_storage_check_list)
    RecyclerView rcStorageCheckList;
    //扫码扫码动作
    private ScanBean scanBean;

    private Unbinder unbinder;

    //待查验数据
    private List<JSONObject> checkList = new ArrayList<>(); ;

    private AvailableFinishWorkAdapter listAdapter;
    // 空显示页
    private View emptyView;

    private JSONObject paramObject;

    protected String action;

    @Override
    public int getContentViewResId() {
        return R.layout.activity_fms_storage_check_list;
    }

    @Override
    public boolean showToolBar() {
        return true;
    }

    @Override
    public boolean openEventBus() {
        return true;
    }

    @Override
    protected void getBundleExtras(Bundle bundle) {
        try {
            paramObject = new JSONObject(bundle.getString("param_object"));
            action = bundle.getString("action","storage");
        } catch (JSONException e) {
            XLog.e("接收数据解析："+e.getMessage());
            e.printStackTrace();
        }
    }
    //finish的返回监听
    //这里的requestCode参数，就是上面设置的 1 ，当跳转的页面返回的时候，通过这个加以判断
    //resultCode ,这个参数是在跳转的页面里面规定的，它也是一个int类型的标志
    //第三个参数包含了返回的值
    //如果不需要所跳转的页面返回值，也就不需要这个方法了
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 200 && resultCode == 200)//之前提到的两个标志，在这里显示出了作用
        {
        }
    }


    /**
     * EventBus接收信息的方法，开启后才会调用(非粘性事件)
     *
     * @param event
     */
    @Override
    protected void EventBean(BaseEventBusBean event) {
//        XLog.e("----------接收返回--------------");
//        XLog.e("接收返回："+event.getEventCode());
        if (event != null && event.getEventCode() == EventCode.displacement_refresh){

        }
    }

    @Override
    public boolean isPlayMusic() {
        return true;
    }

    @Override
    protected void initView() {
        unbinder = ButterKnife.bind(this);
        setTitleName("已装柜清单");

        initEdit();

        initAdapter();

        //loadServiceData();

        initData();


    }

    private void initData(){
        getWaitCheckList();
    }


    private void getWaitCheckList(){
        try {
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("outbound_number",paramObject.getString("outbound_number"));
            jsonObject.put("status",paramObject.getInt("status"));

            OkGo.<String>post(Urls.getServiceAddress(this) + Urls.FMS_OUTBOUND_DETAIL).upJson(jsonObject)
                    .execute(new MyDialogCallback(this, true, true) {
                        @Override
                        public void onSuccess(Response<String> response) {
                            super.onSuccess(response);
                            try {
                                ActionBean bean = JsonUtil.getObject(response.body(), ActionBean.class);

                                if(bean.code == 1){
                                    checkList.clear();
                                    if (!bean.data.isEmpty()&& !bean.data.equals("[]")){
                                        JSONArray list = new JSONArray(bean.data);
                                        for (int i = 0; i<list.length(); i++){
                                            checkList.add(list.getJSONObject(i));
                                        }
                                    }
                                    listAdapter.notifyDataSetChanged();
                                }else{
                                    showWarningToast(bean.msg);
                                }
                                int count = checkList.size();
                                String TitleName= paramObject.getInt("status")==10?"未装柜清单("+count+")":"已装柜清单("+count+")";
                                setTitleName(TitleName);
                                //PC-2021032611414 PC-2021032611414
                                //PC-2021032611414

                            } catch (Exception e) {
                                showWarningToast("获取订单清单列表解析错误:"+e.getMessage());
                                e.printStackTrace();
                                XLog.e("获取订单清单列表解析错误",e.getMessage());
                            }
                        }//PC-2021032611414
                    });
        }catch (Exception e){
            showWarningToast(e.getMessage());
            XLog.e("请求订单清单列表信息错误:",e);
        }
    }




    private void initAdapter() {

        emptyView = this.getLayoutInflater().inflate(R.layout.pager_empty, (ViewGroup) rcStorageCheckList.getParent(), false);
        listAdapter = new AvailableFinishWorkAdapter(checkList);
        listAdapter.setEmptyView(emptyView);
        listAdapter.openLoadAnimation(BaseQuickAdapter.SCALEIN);
        rcStorageCheckList.setLayoutManager(new LinearLayoutManager(this));
        rcStorageCheckList.setAdapter(listAdapter);
        // 卡片项点击事件
        listAdapter.setOnItemClickListener(new BaseQuickAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(BaseQuickAdapter adapter, View view, int position) {
                //showLoadDialog("开始调整查验...");
            }
        });
    }

    private class AvailableFinishWorkAdapter extends BaseQuickAdapter<JSONObject, BaseViewHolder> {
        public AvailableFinishWorkAdapter(List<JSONObject> data) {
            super(R.layout.item_storage_check_list, data);
        }

        @Override
        protected void convert(BaseViewHolder holder, JSONObject jsonObject) {
            XLog.e(jsonObject);
            try {
                holder.setText(R.id.mt_order_number, jsonObject.has("order_number")?jsonObject.getString("order_number"):"");
                holder.setText(R.id.mt_inbound_pieces, jsonObject.has("order_number")?jsonObject.getString("inbound_pieces"):"");
                holder.setText(R.id.mt_load_date, jsonObject.has("order_number")?jsonObject.getString("inbound_date"):"");
            } catch (Exception e) {
                XLog.e("查询结果数据渲染失败："+e.getMessage());
                e.printStackTrace();
            }

        }
    }





    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        //XLog.e("event:"+event.getKeyCode());
        if ((event.getKeyCode()==KeyEvent.KEYCODE_DPAD_CENTER || event.getKeyCode()==KeyEvent.KEYCODE_ENTER )  && event.getAction() == KeyEvent.ACTION_DOWN){
            //按确定键

        }
        return super.dispatchKeyEvent(event);
    }

    //监听按键
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        XLog.e("监听按键："+keyCode);XLog.e(event);
        if (scanBean.getIsBroadcast()==0 && StoTongJNI.getIns(mContext).getEventFuction(keyCode)  == StoPdaKeyEvent.KEYCODE_SCAN
                && event.getRepeatCount() == 0) {

            if (StoTongJNI.getIns(mContext).GetScannerIsScanning()) {
//
            } else {
                StoTongJNI.getIns(mContext).SetScannerStart();
            }
        }
        return super.onKeyDown(keyCode, event);
    }

    @SuppressLint("HandlerLeak")
    Handler scanHandler = new Handler() {

        @Override
        public void handleMessage(Message msg) {
            // TODO Auto-generated method stub
            if (msg.obj != null) {

                String scanResult = msg.obj.toString().trim();
                if (!scanResult.isEmpty()){
                    setScanResult(scanResult);
                }
            }

        }

    };
    @Override
    public void onScanResults(String str) {
        Message msg = new Message();
        msg.obj = str;
        scanHandler.sendMessage(msg);


    }


    @Override
    public void onScanResults(String str, int type) {

    }
    /**
     * 定义广播接受
     */
    BroadcastReceiver mReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String scanResult = intent.getStringExtra(scanBean.getDataName());
            if (scanResult==null){return; }
            String scanStatus = "";
            if (!scanBean.getStatusName().isEmpty()){
                scanStatus = intent.getStringExtra(scanBean.getStatusName());
            }else{
                scanStatus = scanResult.isEmpty()? "" : "ok"; //有值 默认是扫码成功;
            }

            //新大陆(MT65,MT90) 需要手动关闭
            if (!scanBean.getActionStop().isEmpty()){
                Intent stopIntent = new Intent(scanBean.getActionStop());
                mContext.sendBroadcast(stopIntent);
            }

            if ("ok".equals(scanStatus)){
                setScanResult(scanResult);
            }else{
                showErrorToast(getString(R.string.scan_failed));
            }
        }
    };

    /**
     * 注册广播
     */
    private void initReceiver(){

        try {

            String scanStr = getScanSetting();
            scanBean = JsonUtil.getObject(scanStr, ScanBean.class);
            Integer is_broadcast = scanBean.getIsBroadcast();//是否广播

            if (is_broadcast ==1){
                IntentFilter mFilter = new IntentFilter(scanBean.getAction());
                this.registerReceiver(mReceiver, mFilter);
            }else{
                //不广播进行处理 jni模式
                String pdaBrand = StoTongJNI.getmPdaBrand();
                if (!pdaBrand.isEmpty()){
                    StoTongJNI.getIns(this).setmScanCB(this);
                    StoTongJNI.getIns(this).SetScannerOn();
                }
            }


        }catch (Exception e) {
            showErrorToast("获取扫码配置失败"+e.getMessage());
            XLog.e("获取扫码配置失败:" + e.getMessage());
        }
    }

    private void initEdit() {


    }

    private OnRxScanerListener mScanerListener = new OnRxScanerListener() {
        @Override
        public void onSuccess(String type, Result result) {
            String scanResult = result.getText();
            switch (type){
                case BaseConfig.COMMON_SCANNER_ONLY:
                    setScanResult(scanResult);

                    break;
            }
        }
        @Override
        public void onFail(String type, String message) {

        }
    };

    //把扫描结果赋值
    private void setScanResult(String scanResult){
        //获取焦点的view对象
        View view=getWindow().getDecorView().findFocus();
        //如果是EditText
        if(view instanceof EditText)
        {
            ((EditText) view).setText(scanResult);

            switch (view.getId()) {
                case R.id.et_order_no:

                    break;
                default:
            }


        }
    }







    @OnClick({})
    public void onViewClicked(View view) {
        Bundle bundle = new Bundle();
        switch (view.getId()) {

            default:
                break;
        }
    }

    @Override
    protected void onDestroy() {
        unbinder.unbind();


        super.onDestroy();
    }
    @Override
    protected void onResume() {
        super.onResume();
        initReceiver();
    }
    @Override
    protected void onPause() {
        super.onPause();
        //销毁在onResume()方法中的广播
        try {
            //停止扫描
            Integer is_broadcast = scanBean.getIsBroadcast();//是否广播
            if (is_broadcast==0){
                StoTongJNI.getIns(mContext).SetScannerStop();
                StoTongJNI.getIns(mContext).SetScannerOff();
            }else{
                unregisterReceiver(mReceiver);
            }
        }catch (Exception e){
            XLog.e("销毁广播失败：",e.getMessage());
        }
    }


}
